function ObjVal = benchmark_func(x, func_num)

if     func_num == 1 fhd = str2func('Stepint');
elseif func_num == 2 fhd = str2func('Step');
elseif func_num == 3 fhd = str2func('Sphere');
elseif func_num == 4 fhd = str2func('SumSquares');
elseif func_num == 5 fhd = str2func('Quartic');
elseif func_num == 6 fhd = str2func('Beale');
elseif func_num == 7 fhd = str2func('Easom');
elseif func_num == 8 fhd = str2func('Matyas');
elseif func_num == 9 fhd = str2func('Colville');
elseif func_num == 10 fhd = str2func('Trid6');
elseif func_num == 11 fhd = str2func('Trid10');
elseif func_num == 12 fhd = str2func('Zakharov');
elseif func_num == 13 fhd = str2func('Powell');
elseif func_num == 14 fhd = str2func('Schwefel2_22');
elseif func_num == 15 fhd = str2func('Schwefel1_2');
elseif func_num == 16 fhd = str2func('Rosenbrock');
elseif func_num == 17 fhd = str2func('Dixon_Price');
elseif func_num == 18 fhd = str2func('Foxholes');
elseif func_num == 19 fhd = str2func('Branin');
elseif func_num == 20 fhd = str2func('Bohachevsky1');
elseif func_num == 21 fhd = str2func('Booth');
elseif func_num == 22 fhd = str2func('Rastrigin');
elseif func_num == 23 fhd = str2func('Schwefel');
elseif func_num == 24 fhd = str2func('Michalewicz2');
elseif func_num == 25 fhd = str2func('Michalewicz5');
elseif func_num == 26 fhd = str2func('Michalewicz10');
elseif func_num == 27 fhd = str2func('Schaffer');
elseif func_num == 28 fhd = str2func('SHCB');
elseif func_num == 29 fhd = str2func('Bohachevsky2');
elseif func_num == 30 fhd = str2func('Bohachevsky3');
elseif func_num == 31 fhd = str2func('Shubert');
elseif func_num == 32 fhd = str2func('GoldSteinPrice');
elseif func_num == 33 fhd = str2func('Kowalik');
elseif func_num == 34 fhd = str2func('Shekel5');
elseif func_num == 35 fhd = str2func('Shekel7');
elseif func_num == 36 fhd = str2func('Shekel10');
elseif func_num == 37 fhd = str2func('Perm');
elseif func_num == 38 fhd = str2func('PowerSum');
elseif func_num == 39 fhd = str2func('Hartman3');
elseif func_num == 40 fhd = str2func('Hartman6');
elseif func_num == 41 fhd = str2func('Griewank');
elseif func_num == 42 fhd = str2func('Ackley');
elseif func_num == 43 fhd = str2func('Penalized1');
elseif func_num == 44 fhd = str2func('Penalized2');
elseif func_num == 45 fhd = str2func('Langerman2');
elseif func_num == 46 fhd = str2func('Langerman5');
elseif func_num == 47 fhd = str2func('Langerman10');
elseif func_num == 48 fhd = str2func('FletcherPowell2');
elseif func_num == 49 fhd = str2func('FletcherPowell5');
elseif func_num == 50 fhd = str2func('FletcherPowell10');
    
end

ObjVal = feval(fhd,x);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%      Functions Formulate      %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      1. Stepint Function
function ObjVal = Stepint(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + ceil(Cs(:,j));
end

ObjVal = fitness + 25;
%%

%      2. Step Function
function ObjVal = Step(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + (floor(Cs(:,j) + 0.5)).^2;
end

ObjVal = fitness;
%%

% 	3.Sphere Function
function ObjVal=Sphere(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + Cs(:,j).^2;
end

ObjVal = fitness;
%%

% 	4.SumSquares Function
function ObjVal=SumSquares(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + j*Cs(:,j).^2;
end

ObjVal = fitness;

%%

%   5. Quartic
function ObjVal = Quartic(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + j.*Cs(:,j).^4;
end

ObjVal = fitness + rand(1);
%%

%       6. Beale
function ObjVal = Beale(Cs)
ObjVal = (1.5 - Cs(:,1) + Cs(:,1).*Cs(:,2)).^2 + (2.25 - Cs(:,1) + Cs(:,1).*Cs(:,2).^2).^2 + (2.625 - Cs(:,1) + Cs(:,1).*Cs(:,2).^3).^2;
%%

%       7. Easom
function ObjVal = Easom(Cs)
ObjVal = -cos(Cs(:,1)).*cos(Cs(:,2)).*exp(-(Cs(:,1) - pi).^2 - (Cs(:,2) - pi).^2);
%%

%       8. Matyas
function ObjVal = Matyas(Cs)
ObjVal = 0.26.*(Cs(:,1).^2 + Cs(:,2).^2) - 0.48.*Cs(:,1).*Cs(:,2);
%%

%    9. Colville 4 boyutlu
function ObjVal = Colville(Cs)
ObjVal = 100.*(Cs(:,1).^2 - Cs(:,2)).^2 + (Cs(:,1) - 1).^2 + (Cs(:,3) - 1).^2 +...
    90.*(Cs(:,3).^2 - Cs(:,4)).^2 + 10.1.*((Cs(:,2)-1).^2 + (Cs(:,4)-1).^2) +...
    19.8 .* (Cs(:,2)-1).*(Cs(:,4)-1);
%%

%    10. Trid6 boyutlu
function  ObjVal = Trid6(Cs)
dim = size(Cs,2);

f1 = 0;
f2 = 0;
for j = 1:dim
    f1 = f1 + (Cs(:,j) - 1).^2;
end
for j = 2:dim
    f2 = f2 + Cs(:,j).*Cs(:,j-1);
end

ObjVal = f1 - f2;
%%

%    11. Trid10 boyutlu
function  ObjVal = Trid10(Cs)
dim = size(Cs,2);

f1 = 0;
f2 = 0;
for j = 1:dim
    f1 = f1 + (Cs(:,j) - 1).^2;
end
for j = 2:dim
    f2 = f2 + Cs(:,j).*Cs(:,j-1);
end

ObjVal = f1 - f2;
%%

%     12.Zakharov Function
function ObjVal = Zakharov(Cs)
dim = size(Cs,2);

f1 = 0;
f2 = 0;
f3 = 0;
for j = 1:dim
    f1 = f1 + Cs(:,j).^2;
    f2 = f2 + 0.5.*j.*Cs(:,j);
    f3 = f3 + 0.5.*j.*Cs(:,j);
end

ObjVal = f1 + f2.^2 + f3.^4;
%%

% 13.Powell Function
function ObjVal = Powell(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim/4
    fitness = fitness + (Cs(:,4*j-3) + 10.*Cs(:,4*j-2)).^2 + 5.*(Cs(:,4*j-1) - Cs(:,4*j)).^2 + (Cs(:,4*j-2) - Cs(:,4*j-1)).^4 + 10.*(Cs(:,4*j-3) - Cs(:,4*j)).^4;
end

ObjVal = fitness;
%%

%     14.Schwefel 2.22 Function
function ObjVal = Schwefel2_22(Cs)
dim = size(Cs,2);

f1 = 0;
f2 = 1;
for j = 1:dim
    f1 = f1 + abs(Cs(:,j));
    f2 = f2 .* abs(Cs(:,j));
end

ObjVal = f1 + f2;
%%

%15.Schwefel 1.2 Function
function ObjVal = Schwefel1_2(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    f1 = 0;
    for k = 1:j
        f1 = f1 + Cs(:,k);
    end
    fitness = fitness + f1.^2;
end

ObjVal = fitness;
%%

%    16.Rosenbrock Function
function ObjVal = Rosenbrock(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim-1
    fitness = fitness + 100 * (Cs(:,j+1) - Cs(:,j).^2).^2 + (Cs(:,j) - 1).^2;
end

ObjVal = fitness;
%%

%     17. Dixon_Price
function ObjVal = Dixon_Price(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 2:dim
    fitness = fitness + j.*(2.*Cs(:,j).^2 - Cs(:,j-1)).^2;
end

ObjVal = fitness + (Cs(:,1) - 1).^2;
%%

%18. Foxholes
function ObjVal=Foxholes(Cs)
ai0 = [-32, -16, 0, 16, 32];
a = [repmat(ai0, 1, 5);reshape(repmat(ai0, 5 , 1), 1, 25);];

f2 = 0;
for j = 1:25
    f1 = 0;
    for k = 1:2
        f1 = f1 + (Cs(:,k) - a(k,j)).^6;
    end
    f2 = f2 + 1 ./ (j + f1);
end

ObjVal = 1 ./ ((1/500) + f2);
%%

%    19.Branin
function ObjVal = Branin(Cs)
ObjVal = (Cs(:,2) - (5.1/(4*pi^2)).*Cs(:,1).^2 + (5/pi).*Cs(:,1) - 6).^2 + 10.*(1 - (1/(8*pi))).*cos(Cs(:,1)) + 10;
%%

%     20.Bohachevsky3 Function  2 Boyut
function ObjVal = Bohachevsky1(Cs)
ObjVal = Cs(:,1).^2 + 2.*Cs(:,2).^2 - 0.3.*cos(3*pi.*Cs(:,1)) - 0.4.*cos(4*pi.*Cs(:,2)) + 0.7;
%%


%     21.Booth Function
function ObjVal = Booth(Cs)
ObjVal = (Cs(:,1) + 2.*Cs(:,2)- 7).^2 + (2.*Cs(:,1) + Cs(:,2) - 5).^2;
%%

%     22.Rastrigin Function
function ObjVal = Rastrigin(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + 10 + (Cs(:,j).^2 - 10.*cos(2*pi.*Cs(:,j)));
end

ObjVal = fitness;
%%

%     23.Schwefel Function
function ObjVal = Schwefel(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + (-Cs(:,j).*sin(sqrt(abs(Cs(:,j)))));
end

ObjVal = fitness;
%%

%       24. Michalewicz2
function ObjVal = Michalewicz2(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + sin(Cs(:,j)).*sin(j.*Cs(:,j).^2 / pi).^20;
end

ObjVal= -fitness;
%%

%       25. Michalewicz5
function ObjVal = Michalewicz5(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + sin(Cs(:,j)).*sin(j.*Cs(:,j).^2 / pi).^20;
end

ObjVal= -fitness;
%%

%       26. Michalewicz10
function ObjVal = Michalewicz10(Cs)
dim = size(Cs,2);

fitness = 0;
for j = 1:dim
    fitness = fitness + sin(Cs(:,j)).*sin(j.*Cs(:,j).^2 / pi).^20;
end

ObjVal= -fitness;
%%

%       27. Schaffer 2 Boyut
function ObjVal = Schaffer(Cs)
ObjVal = 0.5 + (sin(sqrt(Cs(:,1).^2 + Cs(:,2).^2)).^2 - 0.5) ./ (1 + 0.001.*(Cs(:,1).^2 + Cs(:,2).^2)).^2;

%%

%     28.SHCB Function
function ObjVal = SHCB(Cs)
ObjVal = 4.*Cs(:,1).^2 - 2.1.*Cs(:,1).^4 + (1/3).*Cs(:,1).^6 + Cs(:,1).*Cs(:,2) - 4.*Cs(:,2).^2 + 4.*Cs(:,2).^4;
%%

%     29.Bohachevsky2 Function  2 Boyut
function ObjVal = Bohachevsky2(Cs)
ObjVal = Cs(:,1).^2 + 2.*Cs(:,2).^2 - 0.3.*cos(3*pi.*Cs(:,1)).*cos(4*pi.*Cs(:,2)) + 0.3;
%%

%     30.Bohachevsky3 Function  2 Boyut
function ObjVal = Bohachevsky3(Cs)
ObjVal = Cs(:,1).^2 + 2.*Cs(:,2).^2 - 0.3.*cos(3*pi.*Cs(:,1) + 4*pi.*Cs(:,2)) + 0.3;
%%

%       31.Shubert
function ObjVal = Shubert(Cs)
f1 = 0;
f2 = 0;
for j = 1:5
    f1 = f1 + j .* cos((j + 1).* Cs(:,1) + j);
    f2 = f2 + j .* cos((j + 1).* Cs(:,2) + j);
end

ObjVal = f1 .* f2;
%%

%   32. GoldSteinPrice Function   2 boyut
function ObjVal=GoldSteinPrice(Cs)
f1 = 1 + (Cs(:,1) + Cs(:,2) + 1).^2 .* (19 - 14.*Cs(:,1) + 3.*Cs(:,1).^2 - 14.*Cs(:,2) + 6.*Cs(:,1).*Cs(:,2) + 3.*Cs(:,2).^2);
f2 = 30 + (2.*Cs(:,1) - 3.*Cs(:,2)).^2 .* (18 - 32.*Cs(:,1) + 12.*Cs(:,1).^2 + 48.*Cs(:,2) - 36.*Cs(:,1).*Cs(:,2) + 27.*Cs(:,2).^2);

ObjVal = f1 .* f2;
%%
%       33. Kowalik Function
function ObjVal=Kowalik(Cs)
a = [0.1957 0.1947 0.1735 0.1600 0.0844 0.0627 0.0456 0.0342 0.0323 0.0235 0.0246];
b = 1./ [0.25 0.5 1 2 4 6 8 10 12 14 16];

fitness = 0;
for j = 1:11
    f1 = Cs(:,1).*(b(j)^2 + b(j).*Cs(:,2));
    f2 = b(j)^2 + b(j).*Cs(:,3) + Cs(:,4);
    fitness = fitness + (a(j) - f1 ./ f2).^2;
end

ObjVal = fitness;
%%


%       34. Shekel5  4 boyutlu
function ObjVal = Shekel5(Cs)
dim = size(Cs,2);

m = 5;
a = ones(10,4);
a(1,:) = 4.0*a(1,:);
a(2,:) = 1.0*a(2,:);
a(3,:) = 8.0*a(3,:);
a(4,:) = 6.0*a(4,:);
for j = 1:2;
    a(5,2*j-1) = 3.0; a(5,2*j) = 7.0;
    a(6,2*j-1) = 2.0; a(6,2*j) = 9.0;
    a(7,j)     = 5.0; a(7,j+2) = 3.0;
    a(8,2*j-1) = 8.0; a(8,2*j) = 1.0;
    a(9,2*j-1) = 6.0; a(9,2*j) = 2.0;
    a(10,2*j-1)= 7.0; a(10,2*j)= 3.6;
end
c(1) = 0.1; c(2) = 0.2; c(3) = 0.2; c(4) = 0.4; c(5) = 0.4;
c(6) = 0.6; c(7) = 0.3; c(8) = 0.7; c(9) = 0.5; c(10)= 0.5;


fitness = 0;
for j = 1:m
    f1 = 0;
    for i = 1:dim
        f1 = f1 + (Cs(:,i) - a(j,i)).^2;
    end
    fitness = fitness + 1 ./ (f1 + c(j));
end

ObjVal = -fitness;
%%

%    35. Shekel7 4 boyutlu
function ObjVal = Shekel7(Cs)
dim = size(Cs,2);

m = 7;
a = ones(10,4);
a(1,:) = 4.0*a(1,:);
a(2,:) = 1.0*a(2,:);
a(3,:) = 8.0*a(3,:);
a(4,:) = 6.0*a(4,:);
for j = 1:2;
    a(5,2*j-1) = 3.0; a(5,2*j) = 7.0;
    a(6,2*j-1) = 2.0; a(6,2*j) = 9.0;
    a(7,j)     = 5.0; a(7,j+2) = 3.0;
    a(8,2*j-1) = 8.0; a(8,2*j) = 1.0;
    a(9,2*j-1) = 6.0; a(9,2*j) = 2.0;
    a(10,2*j-1)= 7.0; a(10,2*j)= 3.6;
end
c(1) = 0.1; c(2) = 0.2; c(3) = 0.2; c(4) = 0.4; c(5) = 0.4;
c(6) = 0.6; c(7) = 0.3; c(8) = 0.7; c(9) = 0.5; c(10)= 0.5;


fitness = 0;
for j = 1:m
    f1 = 0;
    for i = 1:dim
        f1 = f1 + (Cs(:,i) - a(j,i)).^2;
    end
    fitness = fitness + 1 ./ (f1 + c(j));
end

ObjVal = -fitness;

%%

%    36. Shekel10 4 boyutlu
function ObjVal = Shekel10(Cs)
dim = size(Cs,2);

m = 10;
a = ones(10,4);
a(1,:) = 4.0*a(1,:);
a(2,:) = 1.0*a(2,:);
a(3,:) = 8.0*a(3,:);
a(4,:) = 6.0*a(4,:);
for j = 1:2;
    a(5,2*j-1) = 3.0; a(5,2*j) = 7.0;
    a(6,2*j-1) = 2.0; a(6,2*j) = 9.0;
    a(7,j)     = 5.0; a(7,j+2) = 3.0;
    a(8,2*j-1) = 8.0; a(8,2*j) = 1.0;
    a(9,2*j-1) = 6.0; a(9,2*j) = 2.0;
    a(10,2*j-1)= 7.0; a(10,2*j)= 3.6;
end
c(1) = 0.1; c(2) = 0.2; c(3) = 0.2; c(4) = 0.4; c(5) = 0.4;
c(6) = 0.6; c(7) = 0.3; c(8) = 0.7; c(9) = 0.5; c(10)= 0.5;


fitness = 0;
for j = 1:m
    f1 = 0;
    for i = 1:dim
        f1 = f1 + (Cs(:,i) - a(j,i)).^2;
    end
    fitness = fitness + 1 ./ (f1 + c(j));
end

ObjVal = -fitness;
%%

%       37.Perm
function ObjVal = Perm(Cs)
n = 4;
b = 0.5;
fitness = 0;
for k = 1:n;
    f1 = 0;
    for j = 1:n
        f1 = f1 + (j^k + b).*((Cs(:,j)./ j).^k - 1);
    end
    fitness = fitness + f1.^2;
end

ObjVal = fitness;
%%

%     38.PowerSum function
function ObjVal = PowerSum(Cs)
n = 4;
b = [8,18,44,114];
fitness = 0;
for k = 1:n
    f1 = 0;
    for j = 1:n
        f1 = f1 + Cs(:,j).^k;
    end
    fitness = fitness + (f1 - b(k)).^2;
end

ObjVal = fitness;
%%

% 39.Hartman3
function ObjVal = Hartman3(Cs)
dim = size(Cs,2);

a(:,2)=10.0*ones(4,1);
for j=1:2;
    a(2*j-1,1)=3.0; a(2*j,1)=0.1;
    a(2*j-1,3)=30.0; a(2*j,3)=35.0;
end
c(1)=1.0;c(2)=1.2;c(3)=3.0;c(4)=3.2;
p(1,1)=0.36890;p(1,2)=0.11700;p(1,3)=0.26730;
p(2,1)=0.46990;p(2,2)=0.43870;p(2,3)=0.74700;
p(3,1)=0.10910;p(3,2)=0.87320;p(3,3)=0.55470;
p(4,1)=0.03815;p(4,2)=0.57430;p(4,3)=0.88280;

fitness = 0;
for i = 1:4
    f1 = 0;
    for j = 1:dim
        f1 = f1 + a(i,j).*(Cs(:,j) - p(i,j)).^2;
    end
    fitness = fitness + c(i)*exp(-f1);
end

ObjVal = -fitness;
%%

% 40.Hartman6
function ObjVal = Hartman6(Cs)

dim = size(Cs,2);

a(1,1)=10.0;	a(1,2)=3.0;		a(1,3)=17.0;	a(1,4)=3.5;		a(1,5)=1.7;		a(1,6)=8.0;
a(2,1)=0.05;	a(2,2)=10.0;	a(2,3)=17.0;	a(2,4)=0.1;		a(2,5)=8.0;		a(2,6)=14.0;
a(3,1)=3.0;		a(3,2)=3.5;		a(3,3)=1.7;		a(3,4)=10.0;	a(3,5)=17.0;	a(3,6)=8.0;
a(4,1)=17.0;	a(4,2)=8.0;		a(4,3)=0.05;	a(4,4)=10.0;	a(4,5)=0.1;		a(4,6)=14.0;
c(1)=1.0;c(2)=1.2;c(3)=3.0;c(4)=3.2;
p(1,1)=0.1312;	p(1,2)=0.1696;	p(1,3)=0.5569;	p(1,4)=0.0124;	p(1,5)=0.8283;	p(1,6)=0.5886;
p(2,1)=0.2329;	p(2,2)=0.4135;	p(2,3)=0.8307;	p(2,4)=0.3736;	p(2,5)=0.1004;	p(2,6)=0.9991;
p(3,1)=0.2348;	p(3,2)=0.1451;	p(3,3)=0.3522;	p(3,4)=0.2883;	p(3,5)=0.3047;	p(3,6)=0.6650;
p(4,1)=0.4047;	p(4,2)=0.8828;	p(4,3)=0.8732;	p(4,4)=0.5743;	p(4,5)=0.1091;	p(4,6)=0.0381;

fitness = 0;
for i = 1:4
    f1 = 0;
    for j = 1:dim
        f1 = f1 + a(i,j).*(Cs(:,j) - p(i,j)).^2;
    end
    fitness = fitness + c(i)*exp(-f1);
end

ObjVal = -fitness;
%%

%     41.Griewank Function
function ObjVal = Griewank(Cs)
dim = size(Cs,2);

f1 = 0;
f2 = 1;
for j = 1:dim
    f1 = f1 + (1/4000).*(Cs(:,j)).^2;
    f2 = f2 .* cos(Cs(:,j) / sqrt(j));
end

ObjVal = f1 - f2 + 1;
%%

%     42.Ackley Function
function ObjVal = Ackley(Cs)
dim = size(Cs,2);

a = 20; b = 0.2; c = 2*pi;

f1 = 0; 
f2 = 0;
for i = 1:dim
    f1 = f1 + Cs(:,i).^2;
    f2 = f2 + cos(c.*Cs(:,i));
end

ObjVal = -a*exp(-b * sqrt(1/dim*f1)) - exp(1/dim*f2) + a + exp(1);
%%

%     43.Penalized1
function ObjVal = Penalized1(Cs)
dim = size(Cs,2);

for j = 1:dim
    y(:,j) = 1 + 0.25.*(Cs(:,j) + 1);
end

f1 = 10.*sin(pi*y(:,1)).^2;
f2 = 0;
for j = 1:dim-1
    f2 = f2 + (y(:,j) - 1).^2.*(1 + 10.*sin(pi.*y(:,j+1)).^2);
end

ObjVal = (pi/dim).*(f1 + f2 + (y(:,dim) - 1).^2) + findU(Cs, 10, 100, 4,size(Cs,1));
%%




%     44.Penalized2
function ObjVal = Penalized2(Cs)
dim = size(Cs,2);

f1 = sin(pi.*Cs(:,1)).^2;

f2 = 0;
for j = 1:dim-1
    f2 = f2 + (Cs(:,j) - 1).^2.*(1 + sin(3*pi.*Cs(:,j+1)).^2);
end

f3 = (Cs(:,dim) -1).^2 .* (1 + sin(2*pi.*Cs(:,dim)).^2);

ObjVal = 0.1.*(f1 + f2 + f3) + findU(Cs, 5, 100, 4, size(Cs,1));
%%

% 45. Langerman2
function ObjVal = Langerman2(Cs)
dim = size(Cs,2);

fitness = 0;

[a,c] = langermanAC();

for i = 1:dim
    f1 = 0;
    for j = 1:dim
        f1 = f1 + (Cs(:,j) - a(i,j)).^2;
    end
    fitness = fitness + c(i) .* exp((-1/pi)*f1).*cos(pi*f1);
end

ObjVal = -fitness;
%%

% 46. Langerman5
function ObjVal = Langerman5(Cs)
dim = size(Cs,2);

fitness = 0;

[a,c] = langermanAC();

for i = 1:dim
    f1 = 0;
    for j = 1:dim
        f1 = f1 + (Cs(:,j) - a(i,j)).^2;
    end
    fitness = fitness + c(i) .* exp((-1/pi)*f1).*cos(pi*f1);
end

ObjVal = -fitness;
%%

% 47. Langerman10
function ObjVal = Langerman10(Cs)
dim = size(Cs,2);

fitness = 0;

[a,c] = langermanAC();

for i = 1:dim
    f1 = 0;
    for j = 1:dim
        f1 = f1 + (Cs(:,j) - a(i,j)).^2;
    end
    fitness = fitness + c(i) .* exp((-1/pi)*f1).*cos(pi*f1);
end

ObjVal = -fitness;
%%


% 48. FletcherPowell2
function ObjVal = FletcherPowell2(Cs)
dim = size(Cs,2);

fitness = 0;

[ a,b,alph] = FletcherABalpha();

for i = 1:dim
    f1 = 0;
    f2 = 0;
    for j = 1:dim
        f1 = f1 + a(i,j)*sin(alph(j)) + b(i,j)*cos(alph(j));
        f2 = f2 + a(i,j)*sin(Cs(:,j)) + b(i,j)*cos(Cs(:,j));
    end
    fitness = fitness + (f1 - f2).^2;
end

ObjVal = fitness;
%%

% 49. FletcherPowell5
function ObjVal = FletcherPowell5(Cs)
dim = size(Cs,2);

fitness = 0;

[ a,b,alph] = FletcherABalpha();

for i = 1:dim
    f1 = 0;
    f2 = 0;
    for j = 1:dim
        f1 = f1 + a(i,j)*sin(alph(j)) + b(i,j)*cos(alph(j));
        f2 = f2 + a(i,j)*sin(Cs(:,j)) + b(i,j)*cos(Cs(:,j));
    end
    fitness = fitness + (f1 - f2).^2;
end

ObjVal = fitness;
%%

% 50. FletcherPowell10
function ObjVal = FletcherPowell10(Cs)
dim = size(Cs,2);

fitness = 0;

[ a,b,alph] = FletcherABalpha();

for i = 1:dim
    f1 = 0;
    f2 = 0;
    for j = 1:dim
        f1 = f1 + a(i,j)*sin(alph(j)) + b(i,j)*cos(alph(j));
        f2 = f2 + a(i,j)*sin(Cs(:,j)) + b(i,j)*cos(Cs(:,j));
    end
    fitness = fitness + (f1 - f2).^2;
end

ObjVal = fitness;